# Device Example CBun
 
The Device Example CBun demonstrates the basic implementation of the CBun Device element. The device support support is implemented in form of **MyDevice** class which is inherited from the `kr2_bundle_api::CustomDevice` class. It implements all the mandatory lifecycle methods (onCreate/onDestroy and onBind/onUnbind). It also demonstrates how the activation and mounting of the device should be provided via onActivate/onDeactivate and onMount/onUnmount methods. Above that it subscribes some of the system event callbacks (onHWReady, onProgramTerminated). And finally it shows how custom methods (grip) and custom functions (getGripPosition) can be defined.

## Git Clone on Windows

When using `git clone` command on Windows, the git may convert Unix-style `\n` line breaks to Windows-style `\r\n` line breaks on checking files out. Since the CBun build container is Unix based, this automatic line break conversion may cause issues during the CBun development. Therefore make sure that this behaviour is disabled prior cloning this CBun example project by running the following command: 

`git config --global core.autocrlf false`

## Build Environment

The Device Example CBuns comes with the preconfigured CBun build environment which is base on the **Visual Studio Code Dev Containers** extension. With this you can open, debug and build the CBun project in Visual Studio Code on Windows, MacOS or Linux without the need for complicated build environment configuration. 

### Prerequisities

To get started, follow these steps:

1. Install and configure [Docker](https://www.docker.com/get-started) for your operating system, using one of the paths below.

   **Windows / macOS:**

   1. Install Docker [Desktop for Windows/Mac](https://www.docker.com/products/docker-desktop).

   2. If you are using Windows, enable WSL and make sure it is up to date by running the following Command Prompt: `wsl --update`

   **Linux:**

   1. Follow the [official install instructions for Docker CE/EE for your distribution](https://docs.docker.com/install/#supported-platforms).

   2. Add your user to the docker group by using a terminal to run: `sudo usermod -aG docker $USER`

   3. Sign out and back in again so your changes take effect.

2. Install [Visual Studio Code](https://code.visualstudio.com/) or [Visual Studio Code Insiders](https://code.visualstudio.com/insiders/).

3. Install the [Dev Containers extension](https://marketplace.visualstudio.com/items?itemName=ms-vscode-remote.remote-containers). 

### CBun Project Setup

To setup the CBun project in Visual Studio Code, follow these steps:

1. Open your CBun project folder in Visual Studio Code.

2. Click **Yes, I trust the authors**.

3. Click **Reopen in Container** (this may take few minutes).

5. Select the **GCC 8.4.0 x86_64-linux-gnu** as the active Kit.

### CBun Tasks

Finally you can run the following tasks from the Visual Studio Code:

* **CBun: Build** - Builds and assembles your CBun from sources into the `build/device_example.cbun` file.

* **CBun: Build and Install** - Builds and installs your CBun (for integration tests only)

### Integration Test 

The CBun project is equipped with a single integration test ([`tests/integration_test.cpp`](https://gitlab.com/kassowrobots-example-codebase/cbuns/cbun-device-example/-/blob/main/backend/tests/integration_test.cpp)). This test demonstrate how the device instance can be constructed, activated and how you can invoke its methods. Thanks to this, you can debug the device code directly on your development machine. Just beware, that the APIs does not provide any reasonable data, since there is not running robot controller in the CBun development container. 

In order to run the integration test, follow these steps:

1. Open the [`tests/integration_test.cpp`](https://gitlab.com/kassowrobots-example-codebase/cbuns/cbun-device-example/-/blob/main/backend/tests/integration_test.cpp) file in your VSCode.

2. Click the **Play** button.

3. Select the **CBun: Build and Run Active File**.

In order to debug the integration test, follow these steps:

1. Set **Debug** build variant.

2. Place breakpoints into the device or integration test code.

3. Open the [`tests/integration_test.cpp`](https://gitlab.com/kassowrobots-example-codebase/cbuns/cbun-device-example/-/blob/main/backend/tests/integration_test.cpp) file in your VSCode.

4. Click the **Play/Debug** button.

5. Select the **CBun: Build and Run Active File**..

## CBun Assembly

The CBun installer (device_example.cbun) is generated by the **CBun: Build** task in Visual Studio Code if the **Release** build variant is selected. Once the CBun is generated, it can be installed on the real robot from a USB stick or Google Drive.

Follow the steps bellow in order to generate and install the CBun:

1. Open the backend project in Visual Studio Code. 

2. Set **Release** build variant.

3. Run the **CBun: Build** task (**Terminal** -> **Run Task...** -> **CBun: Build**).

4. Copy the CBun installer (**PROJECT_FOLDER/build/device_example.cbun**) to a USB stick.

5. Install the CBun on a real robot from the USB stick.

